#!/usr/bin/python

from twisted.application import internet,service
from twisted.internet.protocol import ServerFactory
from twisted.python import log
from twisted.application.service import IProcess

#import logging

import sys

sys.path.append("/opt/ardi/srv/consolidator")

import time
import incoming
import subscription
import threading
import argparse
import logging

class Core:
    def __init__(self):
        self.points = {}
        self.pointimes = {}
        self.lock = threading.Lock()
        self.lastupdate = 0
        self.subscriptions = []
        pass
    
    def NewDataArrived(self, name, value):
        self.lock.acquire()
        value = value.strip()
        try:
            if self.points[name] != value:
                self.points[name] = value
                self.pointimes[name] = time.time()
        except:
            self.points[name] = value
            self.pointimes[name] = time.time()
            
        self.lock.release()
        self.lastupdate = time.time()

class IncomingService(service.Service):
    def __init__(self, core):
        self.core = core
        pass
    
    def startService(self):
        service.Service.startService(self)
        pass

class OutgoingService(service.Service):
    def __init__(self,core):
        self.core = core
        pass
    
    def startService(self):
        service.Service.startService(self)
        
class IncomingFactory(ServerFactory):
    protocol = incoming.Submission
    def __init__(self, service):
        self.service = service
        
    def buildProtocol(self, addr):
        return incoming.Submission(self)

#class ConsolidatorFactory:
def ConsolidatorFactory(inport,outport,srv):
    
    core = Core()
    
    top_service = service.MultiService()

    inserv = IncomingService(core)
    inserv.setServiceParent(top_service)

    infact = IncomingFactory(inserv)
    tcp_service = internet.TCPServer(int(inport),infact)
    tcp_service.setServiceParent(top_service)

    site = subscription.GetService(core)
    tcp_service = internet.TCPServer(int(outport),site)
    tcp_service.setServiceParent(top_service)

    return top_service
        