#!/usr/bin/python

from twisted.internet.protocol import Protocol

from twisted.internet.protocol import Factory
from twisted.internet.endpoints import TCP4ServerEndpoint
from twisted.internet import reactor
import logging

class Submission(Protocol):
    def __init__(self, factory):
        self.factory = factory
        pass
    
    def dataReceived(self,data):
        #logging.warning(data);
        dta = str(data)
        pieces = dta.split("\r\n");
        for pc in pieces:            
            bits = pc.split('=')
            if len(bits) == 2:
                #print bits[0] + ' = ' + bits[1]
                self.factory.service.core.NewDataArrived(bits[0],bits[1])        
    
    def connectionMade(self):
        pass
    
    def connectionLost(self, reason):
        pass

class SubmissionFactory(Factory):
    def __init__(self,core):
        self.core = core
        
    def buildProtocol(self,addr):
        return Submission(self)
    
class SubmissionService:
    def __init__(self,core):
        self.core = core
        self.endpoint = None
        pass
    
    def run(self):
        endpoint = TCP4ServerEndpoint(reactor,5336)
        endpoint.listen(SubmissionFactory(self.core))