from twisted.web import server, resource, http
import threading
import traceback

class HistoryAccess(resource.Resource):
  def __init__(self,core):
      self.core = core;
      resource.Resource.__init__(self)
      self.putChild('reload', ReloadHandler(self.core))
      self.putChild('reconfigure', ReloadHandler(self.core))
      self.putChild('query', QueryHandler(self.core))      
      
  def getChild(self, path, request):
      return ShowMessage("Nothing")
	      
class ReloadHandler(resource.Resource):
  def __init__(self, drv):
        self.core = drv;
        resource.Resource.__init__(self)
				   
  def getChild(self, path, request):
        return ShowMessage(path)
    
  def render_GET(self, request):
        try:
            self.core.Reload(request.args['id'][0])
            return "Success"
        except Exception as inst:
            print type(inst)
            traceback.print_exc()
            return "Error"
    
class QueryHandler(resource.Resource):
  def __init__(self, drv):
        self.core = drv;
        resource.Resource.__init__(self)
				   
  def getChild(self, path, request):
        return ShowMessage(path)
    
  def render_GET(self, request):
		print 'Attempting To Load Query!'
        #try:
		func = "raw"
		try:
			func = request.args['function'][0]
		except:
			func = "raw"
		val = self.core.Query(request.args['id'][0],request.args['points'][0].split('|'),request.args['start'][0],request.args['end'][0],func)
		return val
        #except:
        #    return "Error"

class EmptyChild(resource.Resource):
     def __init__(self, path):
             self.path = path
             resource.Resource.__init__(self)
		      
     def render_GET(self, request):
         return ""
			       
     def render_POST(self, request):
         return ""
				        
     def getChild(self, path, request):
          return EmptyChild(path)
						     
class ShowMessage(resource.Resource):
    def __init__(self, path):
        #self.messageStore = messageStore
	self.path = path
	resource.Resource.__init__(self)
		     
    def render_GET(self, request):
        return "Close, but not quite!";
                
    def getChild(self, path, request):
        return EmptyChild(path)
	